Package org.apache.commons.io.output

# Class DeferredFileOutputStream

java.lang.Object
java.io.OutputStream
org.apache.commons.io.output.ThresholdingOutputStream
org.apache.commons.io.output.DeferredFileOutputStream

All Implemented Interfaces:
  `Closeable`, `Flushable`, `AutoCloseable`

public class DeferredFileOutputStream extends ThresholdingOutputStream
An output stream which will retain data in memory until a specified threshold is reached, and only then commit it to disk. If the stream is closed before the threshold is reached, the data will not be written to disk at all.

To build an instance, use `DeferredFileOutputStream.Builder`.

The caller is responsible for deleting the output file (`getFile()`, `getPath()`) created by a DeferredFileOutputStream when the caller only configured a prefix.

The caller is responsible for deleting the output file passed to a constructor or builder through `DeferredFileOutputStream.Builder.setOutputFile(File)` or `DeferredFileOutputStream.Builder.setOutputFile(Path)`.

This class originated in FileUpload processing. In this use case, you do not know in advance the size of the file being uploaded. If the file is small you want to store it in memory (for speed), but if the file is large you want to store it to file (to avoid memory issues).

See Also:
  - `DeferredFileOutputStream.Builder`

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `DeferredFileOutputStream.Builder`
  Builds a new `DeferredFileOutputStream`.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DeferredFileOutputStream(int threshold, int initialBufferSize, File outputFile)`
  Deprecated.
  Use `builder()`, `DeferredFileOutputStream.Builder`, and `DeferredFileOutputStream.Builder.get()`
  `DeferredFileOutputStream(int threshold, int initialBufferSize, String prefix, String suffix, File directory)`
  Deprecated.
  Use `builder()`, `DeferredFileOutputStream.Builder`, and `DeferredFileOutputStream.Builder.get()`
  `DeferredFileOutputStream(int threshold, File outputFile)`
  Deprecated.
  Use `builder()`, `DeferredFileOutputStream.Builder`, and `DeferredFileOutputStream.Builder.get()`
  `DeferredFileOutputStream(int threshold, String prefix, String suffix, File directory)`
  Deprecated.
  Use `builder()`, `DeferredFileOutputStream.Builder`, and `DeferredFileOutputStream.Builder.get()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DeferredFileOutputStream.Builder`
  `builder()`
  Constructs a new `DeferredFileOutputStream.Builder`.
  `void`
  `close()`
  Closes underlying output stream, and mark this as closed
  `byte[]`
  `getData()`
  Gets the data for this output stream as an array of bytes, assuming that the data has been retained in memory.
  `File`
  `getFile()`
  Gets either the output File specified in the constructor or the temporary File created or null.
  `Path`
  `getPath()`
  Gets either the output Path specified in the constructor or the temporary Path created or null.
  `protected OutputStream`
  `getStream()`
  Deprecated.
  Use `ThresholdingOutputStream.getOutputStream()`.
  `boolean`
  `isInMemory()`
  Tests whether or not the data for this output stream has been retained in memory.
  `protected void`
  `thresholdReached()`
  Switches the underlying output stream from a memory based stream to one that is backed by disk.
  `InputStream`
  `toInputStream()`
  Converts the current contents of this byte stream to an `InputStream`.
  `void`
  `writeTo(OutputStream outputStream)`
  Writes the data from this output stream to the specified output stream, after it has been closed.

  ### Methods inherited from class org.apache.commons.io.output.ThresholdingOutputStream

  `checkThreshold, flush, getByteCount, getOutputStream, getThreshold, isThresholdExceeded, resetByteCount, setByteCount, write, write, write`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DeferredFileOutputStream

    @Deprecated public DeferredFileOutputStream(int threshold, File outputFile)
    Deprecated.
    Use `builder()`, `DeferredFileOutputStream.Builder`, and `DeferredFileOutputStream.Builder.get()`
    Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a file beyond that point. The initial buffer size will default to 1024 bytes which is ByteArrayOutputStream's default buffer size.
    Parameters:
      `threshold` - The number of bytes at which to trigger an event.
      `outputFile` - The file to which data is saved beyond the threshold.

  - ### DeferredFileOutputStream

    @Deprecated public DeferredFileOutputStream(int threshold, int initialBufferSize, File outputFile)
    Deprecated.
    Use `builder()`, `DeferredFileOutputStream.Builder`, and `DeferredFileOutputStream.Builder.get()`
    Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a file beyond that point.
    Parameters:
      `threshold` - The number of bytes at which to trigger an event.
      `initialBufferSize` - The initial size of the in memory buffer.
      `outputFile` - The file to which data is saved beyond the threshold.
    Since:
      2.5

  - ### DeferredFileOutputStream

    @Deprecated public DeferredFileOutputStream(int threshold, int initialBufferSize, String prefix, String suffix, File directory)
    Deprecated.
    Use `builder()`, `DeferredFileOutputStream.Builder`, and `DeferredFileOutputStream.Builder.get()`
    Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a temporary file beyond that point.
    Parameters:
      `threshold` - The number of bytes at which to trigger an event.
      `initialBufferSize` - The initial size of the in memory buffer.
      `prefix` - Prefix to use for the temporary file.
      `suffix` - Suffix to use for the temporary file.
      `directory` - Temporary file directory.
    Since:
      2.5

  - ### DeferredFileOutputStream

    @Deprecated public DeferredFileOutputStream(int threshold, String prefix, String suffix, File directory)
    Deprecated.
    Use `builder()`, `DeferredFileOutputStream.Builder`, and `DeferredFileOutputStream.Builder.get()`
    Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a temporary file beyond that point. The initial buffer size will default to 32 bytes which is ByteArrayOutputStream's default buffer size.
    Parameters:
      `threshold` - The number of bytes at which to trigger an event.
      `prefix` - Prefix to use for the temporary file.
      `suffix` - Suffix to use for the temporary file.
      `directory` - Temporary file directory.
    Since:
      1.4

- ## Method Details

  - ### builder

    public static DeferredFileOutputStream.Builder builder()
    Constructs a new `DeferredFileOutputStream.Builder`.
    Returns:
      a new `DeferredFileOutputStream.Builder`.
    Since:
      2.12.0

  - ### close

    public void close() throws IOException
    Closes underlying output stream, and mark this as closed
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `ThresholdingOutputStream`
    Throws:
      `IOException` - if an error occurs.

  - ### getData

    public byte[] getData()
    Gets the data for this output stream as an array of bytes, assuming that the data has been retained in memory. If the data was written to disk, this method returns `null`.
    Returns:
      The data for this output stream, or `null` if no such data is available.

  - ### getFile

    public File getFile()
    Gets either the output File specified in the constructor or the temporary File created or null.

    If the constructor specifying the File is used then it returns that same output File, even when threshold has not been reached.

    If constructor specifying a temporary File prefix/suffix is used then the temporary File created once the threshold is reached is returned if the threshold was not reached then `null` is returned.

    Returns:
      The File for this output stream, or `null` if no such File exists.

  - ### getPath

    public Path getPath()
    Gets either the output Path specified in the constructor or the temporary Path created or null.

    If the constructor specifying the file is used then it returns that same output Path, even when threshold has not been reached.

    If constructor specifying a temporary Path prefix/suffix is used then the temporary Path created once the threshold is reached is returned if the threshold was not reached then `null` is returned.

    Returns:
      The Path for this output stream, or `null` if no such Path exists.
    Since:
      2.14.0

  - ### getStream

    @Deprecated protected OutputStream getStream() throws IOException
    Deprecated.
    Use `ThresholdingOutputStream.getOutputStream()`.
    Gets the current output stream. This may be memory based or disk based, depending on the current state with respect to the threshold.
    Overrides:
      `getStream` in class `ThresholdingOutputStream`
    Returns:
      The underlying output stream.
    Throws:
      `IOException` - if an error occurs.

  - ### isInMemory

    public boolean isInMemory()
    Tests whether or not the data for this output stream has been retained in memory.
    Returns:
      `true` if the data is available in memory; `false` otherwise.

  - ### thresholdReached

    protected void thresholdReached() throws IOException
    Switches the underlying output stream from a memory based stream to one that is backed by disk. This is the point at which we realize that too much data is being written to keep in memory, so we elect to switch to disk-based storage.
    Overrides:
      `thresholdReached` in class `ThresholdingOutputStream`
    Throws:
      `IOException` - if an error occurs.

  - ### toInputStream

    public InputStream toInputStream() throws IOException
    Converts the current contents of this byte stream to an `InputStream`. If the data for this output stream has been retained in memory, the returned stream is backed by buffers of `this` stream, avoiding memory allocation and copy, thus saving space and time.
    Otherwise, the returned stream will be one that is created from the data that has been committed to disk.
    Returns:
      the current contents of this output stream.
    Throws:
      `IOException` - if this stream is not yet closed or an error occurs.
    Since:
      2.9.0
    See Also:
      - `ByteArrayOutputStream.toInputStream()`

  - ### writeTo

    public void writeTo(OutputStream outputStream) throws IOException
    Writes the data from this output stream to the specified output stream, after it has been closed.
    Parameters:
      `outputStream` - output stream to write to.
    Throws:
      `NullPointerException` - if the OutputStream is `null`.
      `IOException` - if this stream is not yet closed or an error occurs.